#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
ABOUT THIS SCRIPT:
Import CSV data files as tables into Scribus
"""

import sys

try:
    # Please do not use 'from scribus import *' . If you must use a 'from import',
    # Do so _after_ the 'import scribus' and only import the names you need, such
    # as commonly used constants.
    import scribus
except ImportError,err:
    print "This Python script is written for the Scribus scripting interface."
    print "It can only be run from within Scribus."
    sys.exit(1)

#########################
# YOUR IMPORTS GO HERE  #
#########################
import csv

def getCSVdata():
    """opens a csv file, reads it in and returns a 2 dimensional list with the data"""
    csvfile = scribus.fileDialog("csv2table :: open file", "*.csv")
    if csvfile != "":
        try:
            reader = csv.reader(file(csvfile))
            datalist=[]
            for row in reader:
                rowlist=[]
                for col in row:
                    rowlist.append(col)
                datalist.append(rowlist)
            return datalist
        except Exception,  e:
            scribus.messageBox("csv2table", "Could not open file %s"%e)
    else:
        sys.exit


def create(argv):
    """
        - create a page using the "badge" master page.
        - add the text field with the name
        - add the text with the role in the project
    """
    #########################
    #  YOUR CODE GOES HERE  #
    #########################
    userdim=scribus.getUnit() #get unit and change it to mm
    scribus.setUnit(scribus.UNIT_POINTS)
    
    data = getCSVdata()
    
    scribus.progressTotal(len(data))
    scribus.setRedraw(False)
#date 1
    project_x = 42; #original is 54
    project_y = 32;
    project_w = 105; # original of 73
    project_h = 30;
    
#day 1
    projectd_x = 64;
    projectd_y = 60; # original is 49
    projectd_w = 60;
    projectd_h = 40;
    
#title 1
    projectt_x = 145; #original is 131
    projectt_y = 32;
    projectt_w = 210; #original is 223.3
    projectt_h = 55;

#description 1
    projectx_x = 50.63;
    projectx_y = 96.24;
    projectx_w = 288.61;
    projectx_h = 130;

#date 2
    project2_x = 434;
    project2_y = 30;
    project2_w = 105; # original is 73
    project2_h = 30;

#day 2
    projectd2_x = 456;
    projectd2_y = 60;
    projectd2_w = 60;
    projectd2_h = 40;

#title 2 
    projectt2_x = 537;
    projectt2_y = 30;
    projectt2_w = 210;
    projectt2_h = 55;

#description 2
    projectx2_x = 452.63;
    projectx2_y = 95.24;
    projectx2_w = 288.61;
    projectx2_h = 130;

#date 3
    project3_x = 42;
    project3_y = 344;
    project3_w = 105; # original is 73
    project3_h = 30;
#day 3
    projectd3_x = 63;
    projectd3_y = 373;# +312
    projectd3_w = 60;
    projectd3_h = 40;
    
#title 3
    projectt3_x = 145;
    projectt3_y = 344;# +312
    projectt3_w = 210;
    projectt3_h = 55;

#description 3
    projectx3_x = 50.63;
    projectx3_y = 406.24;# +312
    projectx3_w = 288.61;
    projectx3_h = 130;

#date 4
    project4_x = 434;
    project4_y = 344;
    project4_w = 105; # original is 73
    project4_h = 30;
    
#day 4
    projectd4_x = 456;
    projectd4_y = 373;# +312
    projectd4_w = 60;
    projectd4_h = 40;
    
#title 4
    projectt4_x = 537;
    projectt4_y = 344;# +312
    projectt4_w = 210;
    projectt4_h = 55;

#description 4
    projectx4_x = 452.63;
    projectx4_y = 406.24;# +312
    projectx4_w = 288.61;
    projectx4_h = 130;


    i = 0;

    for row in data:
        #if i > 0 :
        #sys.exit(1)
        # scribus.messageBox("csv2table", row)
        #scribus.messageBox("csv2table", row[0])

        # create a page
        scribus.newPage(-1, 'badge');
        # create and fill the text boxes

#date
        textbox2=scribus.createText(project2_x, project2_y, project2_w, project2_h);
        textbox=scribus.createText(project_x, project_y, project_w, project_h);
        textbox3=scribus.createText(project3_x, project3_y, project3_w, project3_h);
        textbox4=scribus.createText(project4_x, project4_y, project4_w, project4_h);
        scribus.insertText(row[5]+"\n"+row[0]+" " +row[2], 0, textbox2);
        scribus.insertText(row[5]+"\n"+row[0]+" " +row[2], 0, textbox);
        scribus.insertText(row[5]+"\n"+row[0]+" " +row[2], 0, textbox3);
        scribus.insertText(row[5]+"\n"+row[0]+" " +row[2], 0, textbox4);
        scribus.setFontSize(11, textbox2);
        scribus.setFontSize(11, textbox);
        scribus.setFontSize(11, textbox3);
        scribus.setFontSize(11, textbox4);
        scribus.setFont('BankGothic Lt BT Light', textbox2);
        scribus.setFont('BankGothic Lt BT Light', textbox);
        scribus.setFont('BankGothic Lt BT Light', textbox3);
        scribus.setFont('BankGothic Lt BT Light', textbox4);
        scribus.setLineSpacing(14, textbox2);
        scribus.setLineSpacing(14, textbox);
        scribus.setLineSpacing(14, textbox3);
        scribus.setLineSpacing(14, textbox4);
	scribus.setTextAlignment(1,textbox2); #1 means centered
	scribus.setTextAlignment(1,textbox);
	scribus.setTextAlignment(1,textbox3);
	scribus.setTextAlignment(1,textbox4);

#day
        textbox2=scribus.createText(projectd2_x, projectd2_y, projectd2_w, projectd2_h);
        textbox=scribus.createText(projectd_x, projectd_y, projectd_w, projectd_h);
        textbox3=scribus.createText(projectd3_x, projectd3_y, projectd3_w, projectd3_h);
        textbox4=scribus.createText(projectd4_x, projectd4_y, projectd4_w, projectd4_h);
        scribus.insertText(row[1], 0, textbox2);
        scribus.insertText(row[1], 0, textbox);
        scribus.insertText(row[1], 0, textbox3);
        scribus.insertText(row[1], 0, textbox4);
        scribus.setFontSize(36, textbox2);
        scribus.setFontSize(36, textbox);
        scribus.setFontSize(36, textbox3);
        scribus.setFontSize(36, textbox4);
        scribus.setFont('BankGothic Lt BT Light', textbox2);
        scribus.setFont('BankGothic Lt BT Light', textbox);
        scribus.setFont('BankGothic Lt BT Light', textbox3);
        scribus.setFont('BankGothic Lt BT Light', textbox4);
        scribus.setLineSpacing(36, textbox2);
        scribus.setLineSpacing(36, textbox);
        scribus.setLineSpacing(36, textbox3);
        scribus.setLineSpacing(36, textbox4);
	scribus.setTextAlignment(1,textbox2); #1 means centered
	scribus.setTextAlignment(1,textbox);
	scribus.setTextAlignment(1,textbox3);
	scribus.setTextAlignment(1,textbox4);


#title
        textbox2=scribus.createText(projectt2_x, projectt2_y, projectt2_w, projectt2_h);
        textbox=scribus.createText(projectt_x, projectt_y, projectt_w, projectt_h);
        textbox3=scribus.createText(projectt3_x, projectt3_y, projectt3_w, projectt3_h);
        textbox4=scribus.createText(projectt4_x, projectt4_y, projectt4_w, projectt4_h);
        scribus.insertText(row[3], 0, textbox2);
        scribus.insertText(row[3], 0, textbox);
        scribus.insertText(row[3], 0, textbox3);
        scribus.insertText(row[3], 0, textbox4);
        scribus.setFontSize(16, textbox2);
        scribus.setFontSize(16, textbox);
        scribus.setFontSize(16, textbox3);
        scribus.setFontSize(16, textbox4);
        scribus.setFont('BankGothic Lt BT Light', textbox2);
        scribus.setFont('BankGothic Lt BT Light', textbox);
        scribus.setFont('BankGothic Lt BT Light', textbox3);
        scribus.setFont('BankGothic Lt BT Light', textbox4);
        scribus.setLineSpacing(12, textbox2);
        scribus.setLineSpacing(12, textbox);
        scribus.setLineSpacing(12, textbox3);
        scribus.setLineSpacing(12, textbox4);
	scribus.setTextAlignment(1,textbox2); #1 means centered
	scribus.setTextAlignment(1,textbox);
	scribus.setTextAlignment(1,textbox3);
	scribus.setTextAlignment(1,textbox4);


#description
        textbox4=scribus.createText(projectx4_x, projectx4_y, projectx4_w, projectx4_h);
        textbox3=scribus.createText(projectx3_x, projectx3_y, projectx3_w, projectx3_h);
        textbox=scribus.createText(projectx_x, projectx_y, projectx_w, projectx_h);
        textbox2=scribus.createText(projectx2_x, projectx2_y, projectx2_w, projectx2_h);
        scribus.insertText(row[4]+"\n\n", 0, textbox2);
        scribus.insertText(row[4]+"\n\n", 0, textbox);
        scribus.insertText(row[4]+"\n\n", 0, textbox3);
        scribus.insertText(row[4]+"\n\n", 0, textbox4);
        scribus.setFontSize(12, textbox4);
        scribus.setFontSize(12, textbox3);
        scribus.setFontSize(12, textbox);
        scribus.setFontSize(12, textbox2);
        scribus.setFont('BankGothic Lt BT Light', textbox4);
        scribus.setFont('BankGothic Lt BT Light', textbox3);
        scribus.setFont('BankGothic Lt BT Light', textbox);
        scribus.setFont('BankGothic Lt BT Light', textbox2);
        scribus.setLineSpacing(14, textbox4);
        scribus.setLineSpacing(14, textbox3);
        scribus.setLineSpacing(14, textbox);
        scribus.setLineSpacing(14, textbox2);
	scribus.setTextAlignment(3,textbox4); #3 means block
	scribus.setTextAlignment(3,textbox3); #3 means block
	scribus.setTextAlignment(3,textbox); #3 means block
	scribus.setTextAlignment(3,textbox2); #3 means block


        i = i + 1;
        scribus.progressSet(i)
    
    scribus.progressReset()
    scribus.setUnit(userdim) # reset unit to previous value
    scribus.docChanged(True)
    scribus.statusMessage("Done")
    scribus.setRedraw(True)


def main(argv):
    """The main() function disables redrawing, sets a sensible generic
    status bar message, and optionally sets up the progress bar. It then runs
    the main() function. Once everything finishes it cleans up after the create()
    function, making sure everything is sane before the script terminates."""
    try:
        scribus.statusMessage("Importing .csv table...")
        scribus.progressReset()
        create(argv)
    finally:
        # Exit neatly even if the script terminated with an exception,
        # so we leave the progress bar and status bar blank and make sure
        # drawing is enabled.
        if scribus.haveDoc():
            scribus.setRedraw(True)
        scribus.statusMessage("")
        scribus.progressReset()

# This code detects if the script is being run as a script, or imported as a module.
# It only runs main() if being run as a script. This permits you to import your script
# and control it manually for debugging.
if __name__ == '__main__':
    main(sys.argv)
